using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace _297___Final_prog
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        static int size = 720;

        Texture2D pph, ppv, ball, bar;
        //Vector2 pphp = new Vector2((size) / 2 - 60, size-50), ppvp = new Vector2(size - 50, (size) / 2 - 60), ballp = new Vector2(size/2, size/2), ballv = new Vector2(50, 300);
        //Vector2 ephp = new Vector2((size) / 2 - 60, 20), epvp = new Vector2(20, (size) / 2 - 60);
        Vector2 pphp, ppvp, ephp, epvp, ballp, ballv; // refer to the init game section

        SpriteFont text;
        int pspeed;
        int bounce;
        int origspeed;

        bool powerupActivate;
        double powerupTimer;

        enum states { Menu, Game, GameOver };
        enum types { two, four };
        enum menu { two, four, exit };
        enum loser { one, two };
        enum powerup { none=0, flip, slow, speed };
        loser curlose;
        powerup curPowerup;
        states gameState = states.Menu;     //initially load the menu of the game
        types gameType = types.two;         //assume a game type of 1 paddle per player to start
        menu menuSel = menu.two;            //start at the top menu option, aka 1 paddle per player


        double gameOverTime;
        Random rand = new Random();

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected void initGame(GameTime gameTime)
        {
            pphp = new Vector2((size)/2 - 60, size-50);     //player 1 horizontal paddle position vector (aka bottom paddle)
            ppvp = new Vector2(size-50, (size)/2 - 60);     //player 1 vertical paddle position vector (aka right paddle)
            ephp = new Vector2((size)/2 - 60, 20);          //player 2 horizontal paddle position vector (aka top paddle)
            epvp = new Vector2(20, (size)/2 - 60);          //player 2 vertical paddle position vector (aka left paddle)
            ballp = new Vector2(size/2, size/2);            //vector that stores the position of the ball
            ballv = new Vector2(rand.Next(500)-250,rand.Next(500)-250); //vector that stores the velocity of the ball

            bounce = 6;     //constant that affects the amound of side to side movement a paddle imparts on the ball

            //make the initial ball speed not suck
            if (ballv.X > 0 && ballv.X < 100) ballv.X = 100;    
            if (ballv.X < 0 && ballv.X > -100) ballv.X = -100;
            if (ballv.Y > 0 && ballv.Y < 100) ballv.Y = 100;
            if (ballv.Y < 0 && ballv.Y > -100) ballv.Y = -100;
            pspeed = 500;   //set the speed that paddles move at
            origspeed = pspeed;     //for restoring the correct speed after a speedup or slowdown
            
            //for keeping track of powerups
            curPowerup = powerup.none;
            powerupActivate = false;
            powerupTimer = gameTime.TotalGameTime.TotalSeconds;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            pph = Content.Load<Texture2D>("playerpaddlehorizontal");
            ppv = Content.Load<Texture2D>("playerpaddlevertical");
            ball = Content.Load<Texture2D>("ball");
            text = Content.Load<SpriteFont>("font");
            bar = Content.Load<Texture2D>("sizingbar");

            // TODO: use this.Content to load your game content here
            graphics.PreferredBackBufferHeight = size;
            graphics.PreferredBackBufferWidth = size;
            graphics.ApplyChanges();
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit

            //Does this default code actually work?, not that it matters
            //if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
            //    this.Exit();

            if (gameState == states.Game)   //handle all the updating for what we do during the game
            {
                //randomly pick powerups ever so many seconds (between 10 and 15 in this case)
                if ((((curPowerup == powerup.none) && (powerupTimer + rand.Next(10,16)) < gameTime.TotalGameTime.TotalSeconds)
                    || ((curPowerup == powerup.flip) && (powerupTimer + 5) < gameTime.TotalGameTime.TotalSeconds)       //timers for individual powerups
                    || ((curPowerup == powerup.slow) && (powerupTimer + 10) < gameTime.TotalGameTime.TotalSeconds)      //control flip is only 5 sec
                    || ((curPowerup == powerup.speed) && (powerupTimer + 10) < gameTime.TotalGameTime.TotalSeconds)))   //speed and slow are 10
                {
                    if (ballp.Y > 250 && ballp.Y < 470 && (gameType == types.two || (ballp.X > 250 && ballp.X < 470)))  //make sure the ball isnt in a place that makes it impossible to recieve due to the powerup
                    {
                        if (curPowerup != powerup.none) curPowerup = powerup.none;  //in the case that a powerup is ending
                        else curPowerup = (powerup)rand.Next(1, 4);
                        pspeed = origspeed;
                        powerupTimer = gameTime.TotalGameTime.TotalSeconds;
                        powerupActivate = true;
                    }
                }
                
                //make the games changes that actually reflect the powerups
                float controlFlip = (curPowerup == powerup.flip) ? -1.0f : 1.0f;
                pspeed = (curPowerup == powerup.slow) ? pspeed-2 : pspeed;
                pspeed = (curPowerup == powerup.speed) ? pspeed+7 : pspeed;
                if (pspeed < 100) pspeed = 100;
                if (pspeed > 6000) pspeed = 1800;

                //All code relating to the ball, aka ball movement, collisions, victory checking
                handleball(gameTime);

                //movement for player 1's bottom paddle
                if (Keyboard.GetState().IsKeyDown(Keys.Left) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadLeft))
                    pphp.X = pphp.X - (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds)*controlFlip;
                if (Keyboard.GetState().IsKeyDown(Keys.Right) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadRight))
                    pphp.X = pphp.X + (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                //bound the paddle so it cant leave the screen
                if (pphp.X < 0) pphp.X = 0;
                if (pphp.X > 600) pphp.X = 600;

                //movement for player 2's top paddle
                if (Keyboard.GetState().IsKeyDown(Keys.A) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadLeft))
                    ephp.X = ephp.X - (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                if (Keyboard.GetState().IsKeyDown(Keys.D) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadRight))
                    ephp.X = ephp.X + (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds * controlFlip);
                //bound the paddle so it cant leave the screen
                if (ephp.X < 0) ephp.X = 0;
                if (ephp.X > 600) ephp.X = 600;

                if (gameType == types.four) //handle the movement for the extra paddles when we have them
                {
                    //movement for player 1's right paddle
                    if (Keyboard.GetState().IsKeyDown(Keys.Up) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadUp))
                        ppvp.Y = ppvp.Y - (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                    if (Keyboard.GetState().IsKeyDown(Keys.Down) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadDown))
                        ppvp.Y = ppvp.Y + (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                    //bound the paddle so it cant leave the screen
                    if (ppvp.Y < 0) ppvp.Y = 0;
                    if (ppvp.Y > 600) ppvp.Y = 600;

                    //movement for player 2's left paddle
                    if (Keyboard.GetState().IsKeyDown(Keys.W) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadUp))
                        epvp.Y = epvp.Y - (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                    if (Keyboard.GetState().IsKeyDown(Keys.S) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadDown))
                        epvp.Y = epvp.Y + (float)(pspeed * gameTime.ElapsedGameTime.TotalSeconds) * controlFlip;
                    //bound the paddle so it cant leave the screen
                    if (epvp.Y < 0) epvp.Y = 0;
                    if (epvp.Y > 600) epvp.Y = 600;
                }

                
                base.Update(gameTime);
            }
            else if (gameState == states.GameOver)
            {
                //this screen is when a player wins before it returns to the menu

                //move to the menu after 3 seconds
                if (gameTime.TotalGameTime.TotalSeconds > (gameOverTime + 3))
                {
                    gameState = states.Menu;
                    gameOverTime = gameTime.TotalGameTime.TotalSeconds;
                }
                //or if a player his a on a control or any key on the keyboard
                if (Keyboard.GetState().GetPressedKeys().Length > 0 || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.A) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.A))
                {
                    gameState = states.Menu;
                    gameOverTime = gameTime.TotalGameTime.TotalSeconds;
                }

            }
            else if (gameState == states.Menu)
            {
                //handles all the navigation of the menues
                if ((Keyboard.GetState().IsKeyDown(Keys.Up) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadUp) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadUp)) && gameTime.TotalGameTime.TotalSeconds > (gameOverTime + 0.3))
                {
                    //use the timer on the menus to prevent moveing throught items too quickly
                    gameOverTime = gameTime.TotalGameTime.TotalSeconds;
                    //keep track of where we are on the menu so we can highlight it
                    if (menuSel == menu.two) menuSel = menu.exit;
                    else if (menuSel == menu.four) menuSel = menu.two;
                    else if (menuSel == menu.exit) menuSel = menu.four;
                }
                else if ((Keyboard.GetState().IsKeyDown(Keys.Down) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.DPadDown) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.DPadDown)) && gameTime.TotalGameTime.TotalSeconds > (gameOverTime + 0.3))
                {
                    //use the timer on the menus to prevent moveing throught items too quickly
                    gameOverTime = gameTime.TotalGameTime.TotalSeconds;
                    //keep track of where we are on the menu so we can highlight it
                    if (menuSel == menu.two) menuSel = menu.four;
                    else if (menuSel == menu.four) menuSel = menu.exit;
                    else if (menuSel == menu.exit) menuSel = menu.two;
                }
                else if ((Keyboard.GetState().IsKeyDown(Keys.Enter) || GamePad.GetState(PlayerIndex.One).IsButtonDown(Buttons.A) || GamePad.GetState(PlayerIndex.Two).IsButtonDown(Buttons.A))  && gameTime.TotalGameTime.TotalSeconds > (gameOverTime + 0.3))
                {
                    //handle the selections of a menu item
                    if (menuSel == menu.two)
                    {
                        //set the correct game mode, initalize the paddles and balls, switch into the game
                        gameType = types.two;
                        initGame(gameTime);
                        gameState = states.Game;
                    }
                    else if (menuSel == menu.four)
                    {
                        //set the correct game mode, initalize the paddles and balls, switch into the game
                        gameType = types.four;
                        initGame(gameTime);
                        gameState = states.Game;
                    }
                    else if (menuSel == menu.exit)
                    {
                        //exit the game
                        this.Exit();
                    }
                }
            }
        }

        //All code relating to the ball, aka ball movement, collisions, victory checking
        protected void handleball(GameTime gameTime)
        {
            //move the ball
            ballp.X = ballp.X + (float)(ballv.X * gameTime.ElapsedGameTime.TotalSeconds);
            ballp.Y = ballp.Y + (float)(ballv.Y * gameTime.ElapsedGameTime.TotalSeconds);
            //bounce the ball off the bottom paddle
            if (ballp.Y > size-55 && ballp.Y < size-45 && ballv.Y > 0 && ballp.X >= pphp.X && ballp.X <= (pphp.X + 120))
            {
                ballv.Y = -ballv.Y;
                ballv.X = (ballp.X - pphp.X - 60) * bounce;
                if (ballv.X > 0 && ballv.X < 75) ballv.X = 75;
                else if (ballv.X < 0 && ballv.X > -75) ballv.X = -75;
            }
            //bounce the ball off the side paddle
            if (ballp.Y < 55 && ballp.Y > 45 && ballv.Y < 0 && ballp.X >= ephp.X && ballp.X <= (ephp.X + 120))
            {
                ballv.Y = -ballv.Y;
                ballv.X = (ballp.X - ephp.X - 60) * bounce;
                if (ballv.X > 0 && ballv.X < 75) ballv.X = 75;
                else if (ballv.X < 0 && ballv.X > -75) ballv.X = -75;
            }
            //bounce for the extra two side paddles when we have them
            if (gameType == types.four)
            {
                //right
                if (ballp.X > size-55 && ballp.X < size-45 && ballv.X > 0 && ballp.Y >= ppvp.Y && ballp.Y <= (ppvp.Y + 120)) 
                {
                    ballv.X = -ballv.X;
                    ballv.Y = (ballp.Y - ppvp.Y - 60) * bounce;
                    if (ballv.Y > 0 && ballv.Y < 75) ballv.Y = 75;
                    else if (ballv.Y < 0 && ballv.Y > -75) ballv.Y = -75;
                }
                //left
                if (ballp.X < 55 && ballp.X > 45 && ballv.X < 0 && ballp.Y >= epvp.Y && ballp.Y <= (epvp.Y + 120))
                {
                    ballv.X = -ballv.X;
                    ballv.Y = (ballp.Y - epvp.Y - 60) * bounce;
                    if (ballv.Y > 0 && ballv.Y < 75) ballv.Y = 75;
                    else if (ballv.Y < 0 && ballv.Y > -75) ballv.Y = -75;
                }
            }
            //otherwise make the walls bounce the ball
            else
            {
                if (ballp.X < 0) { ballp.X = 0; ballv.X = -ballv.X; }
                if (ballp.X > size) { ballp.X = size; ballv.X = -ballv.X; }

                //also, every so often increase the ball's y speed to make a single paddle per player game not stalemate
                if (rand.Next(0, 100) > 92) ballv.Y += (ballv.Y>0)?1:-1;
            }


            if (ballp.Y > size - 5 || (gameType == types.four && ballp.X > size - 5)) { curlose = loser.one; gameState = states.GameOver; gameOverTime = gameTime.TotalGameTime.TotalSeconds; }
            if (ballp.Y < 5 || (gameType == types.four && ballp.X < 5)) { curlose = loser.two; gameState = states.GameOver; gameOverTime = gameTime.TotalGameTime.TotalSeconds; }
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            if (gameState == states.Game)
            {
                //draw the stuff for the game

                //top and bottom paddles + the ball
                spriteBatch.Draw(pph, pphp, Color.White);
                spriteBatch.Draw(pph, ephp, Color.Red);
                spriteBatch.Draw(ball, ballp, null, Color.White, 0.0f, new Vector2(8, 8), 1.0f, SpriteEffects.None, 0);

                if (gameType == types.four)
                {
                    //draw left and right paddles when we have them
                    spriteBatch.Draw(ppv, ppvp, Color.White);
                    spriteBatch.Draw(ppv, epvp, Color.Red);
                }

                if (powerupActivate == true && curPowerup != powerup.none)
                {
                    //draw text that tells the players of the current powerup that is in effect
                    if (curPowerup == powerup.flip) spriteBatch.DrawString(text, "Control Flip!", new Vector2(320, 360), Color.White);
                    if (curPowerup == powerup.slow) spriteBatch.DrawString(text, "Paddle Slow Down!", new Vector2(320, 360), Color.White);
                    if (curPowerup == powerup.speed) spriteBatch.DrawString(text, "Paddle Speed Up!", new Vector2(320, 360), Color.White);
                }
                
            }
            else if (gameState == states.GameOver)
            {
                //gameover screen, show who wins
                spriteBatch.DrawString(text, "Game Over", new Vector2(350, 300), Color.White);
                spriteBatch.DrawString(text, (curlose == loser.one) ? "Player 2 wins!" : "Player 1 wins!", new Vector2(320, 350), Color.Red);
            }
            else if (gameState == states.Menu)
            {
                //list the menu options and highlight the one we are currently on
                spriteBatch.DrawString(text, "One paddle per player", new Vector2(300, 300), (menuSel == menu.two) ? Color.Red : Color.White);
                spriteBatch.DrawString(text, "Two paddles per player", new Vector2(300, 350), (menuSel == menu.four) ? Color.Red : Color.White);
                spriteBatch.DrawString(text, "Exit", new Vector2(300, 400), (menuSel == menu.exit) ? Color.Red : Color.White);
            }

            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
